// VUPlayer encoder plug-in header file

// Sample formats accepted by the OpenEx function
#define FORMAT_16BIT	0		// 16-bit signed sample data
#define FORMAT_FLOAT	1		// floating point data (not currently used)

// All tag strings are UTF-8 encoded from v2.2 onwards
typedef struct
{
	int	tracknum;
	LPCTSTR	title;
	LPCTSTR	artist;
	LPCTSTR	album;
	LPCTSTR	genre;			
	LPCTSTR	year;
	LPCTSTR	comment;
} TAGSTRUCT;

// VUPlayer will scan all files in the encoders folder and attempt to call this function.
// Return the description of your plug-in.
LPCTSTR QueryEncoder();

// Do all your encoder setup here and return the output filepath on success, 0 on failure.
// NOTE: dwLength specifies the total number of bytes that will be passed to the encoder.
// NOTE: This function is only used by the CD ripper, use OpenEx for other sample formats.
LPCTSTR Open(LPCTSTR filename, TAGSTRUCT* pTag, DWORD dwLength);

// An extension of the Open function which allows for sample formats other than CDDA.
// freq: sample rate (Hz), chan: number of channels (1 or 2), fmt: sample format.
LPCTSTR OpenEx(LPCTSTR filename, TAGSTRUCT* pTag, DWORD dwLength, DWORD freq, WORD chan, WORD fmt);

// Do all your encoder cleanup here.
void Close();

// Encode a chunk of data, returning 1 on success, 0 on failure.
// NOTE: Maximum dwSize passed by VUPlayer will be 65536.
BOOL Write(BYTE* pData, DWORD dwSize);

// Display your encoder configuration dialog.
void Configure(HINSTANCE hInst, HWND hWnd);
